﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace PWTEditor.SaveFile
{
    class GenericBlock : ChecksumBlock
    {
        protected static readonly int footerSize = 0x4;

        public ushort SaveCount { get; set; }

        public GenericBlock() : this(new byte[0]) { }
        public GenericBlock(byte[] data)
        {
            Data = data;
        }
        public GenericBlock(Stream input, int blockSize)
        {
            LoadBlock(input, blockSize, footerSize);
        }

        protected override void LoadFooter(Stream input)
        {
            BinaryReader reader = new BinaryReader(input);

            SaveCount = reader.ReadUInt16();
            Checksum = reader.ReadUInt16();
        }
        protected override void WriteFooter(Stream output)
        {
            BinaryWriter writer = new BinaryWriter(output);

            writer.Write(SaveCount);
            writer.Write(Checksum);
        }
    }
}
