﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using PWTEditor.SaveFile;

namespace PWTEditor.SaveFile.Tournaments
{
    public class TournamentBlock : SaveBlock
    {
        private static readonly int blockSize = 0x1314;

        // Tournament block size is always 0x1314
        public override uint Size { get { return (uint)blockSize; } }

        public TournamentBlock() : base() { }
        public TournamentBlock(TournamentChecksumBlock tournamentChecksumBlock) : this(tournamentChecksumBlock.ToData().ToArray()) { }
        public TournamentBlock(byte[] data) : base(data) { }
        public TournamentBlock(Stream input) : base(input, blockSize) { }
        protected override ushort CalcChecksum()
        {
            return CRC16CCITT.Calculate(Data, 0x1300, 4);
        }

        public TournamentChecksumBlock TournamentChecksumBlock
        {
            get
            {
                return new TournamentChecksumBlock(new MemoryStream(Data));
            }
            set
            {
                Data = value.ToData().ToArray();
            }
        }
    }
}
